
//import java.io.*;
import java.util.ArrayList;
import java.util.Random;

/**
 * Denne klassen utfrer tjener funksjoenene i simuleringen. 
 * Klassen holder en liste over indekstermer og navn/key/lok 
 * for filene som inneholder indekstermene. 
 * Klassen tar imot indekser som genereres av klientene, og nr den aktiveres s setter den 
 * igang en metode som opplyser alle noder i en viss omkrets om hvor nr denne tjener er. 
 * System
 * 
 * @author Morten Tvenning
 * @version 25 feb
 * 
 *
 */
public class NodeTjener {

	NodeKlient client; 
	ArrayList indexBase, otherServersList;
	boolean active; 
	
	IOClass ioobjekt;
	int antbranoksvar;
	// ArrayList InvIndexFilerIDenneNoden;
	
	/////////////////////////////////////////////////////
	/// Konstruktorer              //////////////////////	
	/////////////////////////////////////////////////////
	
	
	/**
	 * Enkel konstruktor som tar imot en klient som kobles til denne tjeneren. 
	 * Starter opp indekslisten, en liste over andre servere og ett OIobjekt. 
	 * 
	 */
	public NodeTjener(NodeKlient client){
		this.client = client; 
		indexBase = new ArrayList();
		active = false;
		ioobjekt = new IOClass();
		otherServersList = new ArrayList();
		// InvIndexFilerIDenneNoden = new ArrayList();
		// System.out.println("har mekket Server til noden.");
		antbranoksvar = 150;
	}
	
	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	//// 			METODER FOR KLASSEN!! 								/////
	////																/////
	////																/////
	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	
	
	/**
	 * Legger en tjener til denne serverens nodeliste
	 * @param tjener nodeTjeneren som skal legges til. 
	 */
	public void addToOtherServersList(NodeTjener server){
		otherServersList.add(server);
		
	}
	/**
	 * Metode for  sende hele indexen til alle de andre tjenerne denne 
	 * nodeTjeneren vet om. 
	 * 
	 * @return True hvor operasjonen gjennomfres, False om den failer, pga at 
	 * denne noden ikke vet om noen andre nodeTjener. 
	 */
	public boolean sendIndeksBaseListTilAndreTjenere(){
		boolean kangjennomfore = false;
		if(otherServersList.size() >0){
			kangjennomfore = true; 
			for(int i=0; i<otherServersList.size(); i++){
				for(int j=0; j<indexBase.size();j++){
					((NodeTjener)otherServersList.get(i)).leggTilFraTjenerNode((ArrayList)indexBase.get(j));
				}
			}
		}
		
		return kangjennomfore; 
		
	}
	/**
	 * Denne metoden distribuerer indexInserts etter den har lagt den til i sin egen liste. 
	 * Denne metoden styrer ogs hvor mange noder inserten skal sendes videre til. 
	 * 
	 * 
	 * @param indexInsert indeksinsert i form av en ArrayList
	 */
	public void distribuerIndeksTilAndreTjenere(ArrayList indexInsert){
		//System.out.println("Distribueres!! ");
		int serverant = otherServersList.size();
		int hvormangedenskaldistribuerestil = 3;
		
		Random rand = new Random();
		
		if(serverant>0){
			
			if(serverant<hvormangedenskaldistribuerestil){
				for(int i=0;i<serverant;i++){
					((NodeTjener)otherServersList.get(i)).leggTilIndeksBaseFraArrayListForDistribuering(indexInsert);
				}
			}	
			if(serverant>hvormangedenskaldistribuerestil){
				ArrayList temparray = new ArrayList();
				for(int ja=0; ja<serverant; ja++){
					temparray.add(otherServersList.get(ja));
					
				}
				
				ArrayList distto = new ArrayList();
				for(int h=0; h<hvormangedenskaldistribuerestil; h++){
					distto.add(temparray.remove(rand.nextInt(serverant-h)));
					
				}
				for(int o=0; o<hvormangedenskaldistribuerestil; o++){
					// System.out.println("legges til!!!");
					((NodeTjener)distto.get(o)).leggTilIndeksBaseFraArrayListForDistribuering(indexInsert);
				}
				
				
			}
			
		}
		
		
	}
	
	/**
	 * Metode for  legge til en ArrayList til indexBase 
	 * hvor elementene i arraylisten har form
	 * (String)indexInsert, (String)lok1, lok2, lok3... etc.
	 * 
	 * @param innarray ArrayList som inneholder en indeksinnsert og fillokaliseringer. 
	 */
	public void leggTilFraTjenerNode(ArrayList innarray){
		String indexinsert = (String)innarray.get(0);
		// System.out.println("Inserter til annen server  : "+indexinsert );
		for(int i=1; i<innarray.size(); i++){
			this.leggTilIndeksTerm(indexinsert, (String)innarray.get(i));
		}
		
		
	}
	/**
	 * Metode som aktiverer tjenerfunksjonen i en node
	 * Denne metoden styrer hvor mange hopp ut pingen skal g! (Bredden p multikallet)
	 * 
	 */
	
	
	public void aktiverTjener(){
		
		active = true; 
		((NodeKlient)this.getKlient()).goTjenerPing(5, ((NodeKlient)this.getKlient()), 0);
		
	} 
	/**
	 * 
	 * Setter tjeneren til  pinge ut 5 hakk
	 * 
	 */
	public void tjenerPinger(){
		((NodeKlient)this.getKlient()).goTjenerPing(5, ((NodeKlient)this.getKlient()), 0);
	}
		
	/**
	 * Klienten som er knyttet til denne tjeneren
	 * @return nodeClient
	 */
	public NodeKlient getKlient(){
		
		return this.client; 
	}
	
	/**
	 * Denne metoden tar inne en ArrayList som er designet for  legge til indekstermer i listen.
	 *  
	 * 
	 * @param inIndex ArrayList hvor frste element er lok/fil/key og resten av elementene 
	 * i listen er IndexTermer  
	 * @return true om indeksinserten gr an  gjre. false hvis ikke. 
	 */
	public boolean leggtilIndeksBaseFraArrayList(ArrayList inIndex){
		
		boolean returnvalue = true;
		if(inIndex.size() ==0 && inIndex.size() == 1) {
			returnvalue = false;
		}
		else{
			for(int i=1; i<inIndex.size();i++){
				this.leggTilIndeksTerm((String)inIndex.get(i), (String)inIndex.get(0));
						
			}
		}
		this.distribuerIndeksTilAndreTjenere(inIndex);
		return returnvalue;
	}
	
	/**
	 * Denne metoden tar inne en ArrayList som er designet for  legge til indekstermer i listen.
	 * denne metoden kalles bare for  distribuere fra andre tjenere.  
	 * 
	 * @param inIndex ArrayList hvor frste element er lok/fil/key og resten av elementene 
	 * i listen er IndexTermer  
	 * @return true om indeksinserten gr an  gjre. false hvis ikke. 
	 */
	public boolean leggTilIndeksBaseFraArrayListForDistribuering(ArrayList inIndex){
		
		boolean returnvalue = true;
		if(inIndex.size() ==0 && inIndex.size() == 1) {
			returnvalue = false;
		}
		else{
			for(int i=1; i<inIndex.size();i++){
				this.leggTilIndeksTerm((String)inIndex.get(i), (String)inIndex.get(0));
						
			}
		}
		return returnvalue;
	}
	
	/**
	 * Denne metoden skal legge til indexTermer og fil/lok/key disse skal bindes opp til. Finnes 
	 * allerede termen skal bare fil/lok/key legges til. Og fikser om det kommer flere av samme.
	 * Ved  la vre  legge til. 
	 * 
	 * @param indexTerm Termen som skal legges til.
	 * @param lok hvilken fil/key den skal bindes opp til.
	 */
	public void leggTilIndeksTerm(String indexTerm, String lok){
		
		if(indexBase.isEmpty()){
			ArrayList temp = new ArrayList();
			temp.add(indexTerm);
			temp.add(lok);
			indexBase.add(temp);
			//System.out.println("nodeServer: addIndexTerm MAKING NEW LIST if1 added to empty list");
		}
		
		else if(!indexBase.isEmpty() && (this.indeksTermiIndeksBase(indexTerm))>=0){
			int insert = this.indeksTermiIndeksBase(indexTerm);
			// legger til i listen der inserten er
			boolean skalleggetil = true;
			// forsetningen fikser at ikke samme key/navn/lok blir lagt til to ganger.
			for(int j=1;j<((ArrayList)indexBase.get(insert)).size(); j++){
				if(lok.compareTo(((String)((ArrayList)indexBase.get(insert)).get(j)))==0){
					skalleggetil = false;
					// System.out.println("Ikke legge til : " + lok);
				}
			}
			if(skalleggetil){
			((ArrayList)indexBase.get(insert)).add(lok);
			//System.out.println("nodeServer: addIndexTerm if2 added only lok " + indexTerm + " " + lok + " at " + insert);
		 }
		}
		else if(!indexBase.isEmpty() && (this.indeksTermiIndeksBase(indexTerm))== -1){
			int insertspace = this.insertSpaceForNewIndexTerm(indexTerm);
			ArrayList tempelse = new ArrayList(); tempelse.add(indexTerm); tempelse.add(lok); 
			if(insertspace< indexBase.size()){
			indexBase.add(insertspace, tempelse);
			//System.out.println("nodeServer: addIndexTerm if3 if1 added "+ indexTerm + " " + lok + " plass i listen "+ insertspace);
			}
			else{
				indexBase.add(tempelse);
				//System.out.println("nodeServer: addIndexTerm if3 if2 added "+indexTerm+" "+ lok + " plass i listen sist");
			}
		}
		
		
	}
	/**
	 * Denne metoden sjekker om en Streng allerede finnes som frste instans i en liste i 
	 * indexBasen
	 * 
	 * @param indexTerm String for indexTermen som skal settes inn
	 * @return isInList posisjon i listen eller -1 hvis den ikke finnes i listen. 
	 */
	public int indeksTermiIndeksBase(String indexTerm){
		int isInList = -1; 
			for(int i=0; i<indexBase.size(); i++){
				if((indexTerm.compareTo((String)((ArrayList)(indexBase.get(i))).get(0)))==0){
					isInList = i;
					break;
				}
				
		}
		return isInList;
	}
	/**
	 * Metode som finner ut hvor i en allerede alfabetisk liste en ny insert skal settes. 
	 * 
	 * @param indexTerm String index som skal inn i listen
	 * @return int Posisjonen som skal fylles av den nye inserten. 
	 */
	public int insertSpaceForNewIndexTerm(String indexTerm){
		int storste;
		storste=0;
		if(indexBase.size()==1){
			// System.out.println("nodeServer: insertSpaceForNewIndexTerm indexBasesize ==1");
			if((indexTerm.compareToIgnoreCase((String)((ArrayList)(indexBase.get(0))).get(0)))<0){
				return 0;
			}
			else{return 1;}
		}
		else{
			for(int i=0; i<indexBase.size(); i++){
				if((indexTerm.compareToIgnoreCase((String)((ArrayList)(indexBase.get(i))).get(0)))<0){
					storste=i;
					// System.out.println("nodeServer: insertSpaceForNewIndexTerm early return");
					return storste;
					
				}
				
			}
			// System.out.println("nodeServer: insertSpaceForNewIndexTerm " + minste + " " + storste);
			return indexBase.size(); 
	}
	}
	
	
	/**
	 * Returnerer om tjenernoden er aktivert
	 * 
	 * @return boolean true om server er aktivert. 
	 */
	public boolean erAktiv(){
		
		return active; 
}
	/**
	 * 
	 * Printer ut navn p noden og indekslisten til denne tjenernoden. 
	 *
	 */
	public void printThisList(){
		ArrayList temp; 
		
		System.out.println("\n"+"**************************************************" + "\n" + 
								"****** For server: "+ this.getKlient().getNavn() +  "*****" + "\n" +
								"****** Printing indexBaselist for This node ******" + "\n" + 
								"**************************************************"); 

		for(int i =0; i < indexBase.size(); i++){
			temp = (ArrayList)indexBase.get(i);
			for(int j = 0; j < temp.size(); j++){
				if(j == (temp.size()-1)){
					System.out.println((String)temp.get(j));
				}
				else{
					System.out.print((String)temp.get(j) + " ");
				}
			}
			
		}
		
	}
	/**
	 * Metode for  ske igjennom indexbasen til tjeneren, om denne tjeneren ikke 
	 * returnerer nok sketreff opp til en hvis treshhold s sender den sket videre til 
	 * andre tjenere i sin serverbase. 
	 * 
	 * 
	 * @param sokeord skeordet som tjeneren skal finne. 
	 * @return Arrayliste med skeresultatene som inneholder Strenger av typen 
	 * filnavn/lok/key, sket er negativt vil den returnere en liste med en String 
	 * "intetskeresultat"
	 */
	
	public ArrayList sokEtterOrd(String sokeord){
		ArrayList returnliste = new ArrayList();
		returnliste.add("intetskeresultat");
		
		for(int i=0; i< indexBase.size();i++ ){
			if(sokeord.compareTo(((String)((ArrayList)indexBase.get(i)).get(0)))==0){
				//System.out.println("Sket gikk smutt / fint!!");
				returnliste.remove(0);
				for(int j=1;j<((ArrayList)indexBase.get(i)).size();j++){
				returnliste.add(((ArrayList)indexBase.get(i)).get(j));
				}
				// returnliste.remove(0);
			}
			
		}
		boolean ikkeferdig = true;
		ArrayList templiste = new ArrayList();
		boolean leggetil =true;
		int teller =0; 
		while(ikkeferdig){
			if(returnliste.size()<antbranoksvar){
				//System.out.println("listen er mindre enn antbranoksvar eller minste returnverdi");
				templiste = ((NodeTjener)otherServersList.get(teller)).sokFraServerEtterOrd(sokeord);
				if(returnliste.size() ==0){
					returnliste = templiste;
				}
				if(templiste.size()>0){
				leggetil = true; 
				//System.out.println("Det er svar fra denne noden teller er : " +teller);
				for(int a=0; a<templiste.size(); a++){
					for(int b=0; b<returnliste.size();b++){
						//System.out.println("ab: " + a+ " " + b);
						if(((String)templiste.get(a)).compareTo((String)returnliste.get(b))==0){
							leggetil = false;
						}
					}
					if(leggetil){
						returnliste.add(templiste.get(a));
						}
					else{leggetil=true;}
					}
				}
			}
			if(returnliste.size()>=antbranoksvar){
				//System.out.println("returnliste stor nok!!");
				ikkeferdig = false;
			}
			teller++;
			if(teller == otherServersList.size()){
				//System.out.println("ikke flere servere igjen  sjekke, teller er :" + teller);
				ikkeferdig = false;
			}
			
		}
		
		
		return returnliste; 
	}
	/**
	 * Metode som gjr det mulig  ske i andre tjenere uten  ske rekursivt videre. 
	 * Gjr nesten det samme som sokEtterOrd, men sender ikke sket videre om det ikke
	 * er nok treff.
	 * @param sokeord String med ordet du vil ske etter.
	 * @return liste med lokalisasjoner/key/navn ArrayList med strenger. 
	 */
	public ArrayList sokFraServerEtterOrd(String sokeord){
		ArrayList returnliste = new ArrayList();
		returnliste.add("intetskeresultat");
		
		for(int i=0; i< indexBase.size();i++ ){
			if(sokeord.compareTo(((String)((ArrayList)indexBase.get(i)).get(0)))==0){
				// System.out.println("Dist sk");
				returnliste.remove(0);
				for(int j=1;j<((ArrayList)indexBase.get(i)).size();j++){
				returnliste.add(((ArrayList)indexBase.get(i)).get(j));
				}
				// returnliste.remove(0);
			}
			
		}
		return returnliste; 
	}
}
//////////////////////////////////////////////////////////
// gammel kode!!
//////////////////////////////////////////////////////////
